<template>
  <div class="sign-up">
    <nav-bar></nav-bar>
    <div class="columns">
      <aside class="menu column is-1">
        <p class="menu-label">
          General
        </p>
        <ul class="menu-list">
          <li>
            <router-link to="/users">
              <font size="6">Users</font>
            </router-link>
          </li>
          <li>
            <router-link to="/groups">
              <font size="6">Groups</font>
            </router-link>
          </li>
        </ul>
      </aside>
      <table class="table column is-offset-3">
        <thead>
        <tr>
          <th><abbr title="Position">Pos</abbr></th>
          <th>Name</th>
          <th><abbr>Admin</abbr></th>
          <th><abbr>Group</abbr></th>
          <th><abbr>Email</abbr></th>
        </tr>
        </thead>
        <tfoot>
        <tr>
          <th><abbr title="Position">Pos</abbr></th>
          <th>Name</th>
          <th><abbr>Admin</abbr></th>
          <th><abbr>Group</abbr></th>
          <th><abbr>Email</abbr></th>
        </tr>
        </tfoot>
        <tbody>
        <tr :class="{'is-green': user.isChanged}" v-for="(user, index) in users">
          <th>{{index + 1}}</th>
          <th>{{user.name}}</th>
          <th>{{user.admin}}</th>
          <!--<td>{{user.group_id}}</td>-->
          <td>
            <div class="control">
              <div class="select">
                <select v-model="user.group_id">
                  <option>Select Group</option>
                  <option v-for="group in groups" v-show="group.Id" :value="group.Id">{{group.Name}}</option>
                </select>
              </div>
            </div>
          </td>
          <td>{{user.email}}</td>
          <td><span @click="removeFromTable(index, user.rec_id)"><i class="fa fa-trash"></i></span></td>
          <td><span @click="saveChanges(index, user.rec_id, user.group_id)"><i class="fa fa-save"></i></span></td>
        </tr>
        </tbody>
      </table>
    </div>
    <div class="modal is-active columns" v-show="show_me">
      <div class="modal-background"></div>
      <div class="modal-content is-12">
        <div class="column is-10">
          <div class="field">
            <div class="control columns">
              <label class="label column is-3">Name</label>
              <input v-model="new_group.name" class="input column" type="text" placeholder="Text input">
            </div>
          </div>
          <div class="columns">
            <div class="field">
              <div class="control">
                <label class="checkbox">
                  Read
                  <input id="read" type="checkbox">
                </label>
              </div>
            </div>
            <div class="field">
              <div class="control">
                <label class="checkbox">
                  Write
                  <input id="write" type="checkbox">
                </label>
              </div>
            </div>
            <div class="field">
              <div class="control">
                <label class="checkbox">
                  Create
                  <input id="create" type="checkbox">
                </label>
              </div>
            </div>
            <div class="field">
              <div class="control">
                <label class="checkbox">
                  Delete
                  <input id="delete" type="checkbox">
                </label>
              </div>
            </div>
          </div>
          <div class="field">
            <label class="label">Description</label>
            <div class="control">
              <textarea class="textarea" v-model="new_group.description" placeholder="Textarea"></textarea>
            </div>
          </div>
          <div class="field is-grouped columns">
            <div class="control column is-4 is-offset-3">
              <button class="button is-info" id="buttn">Create</button>
            </div>
          </div>
        </div>
      </div>
      <button class="modal-close is-large" aria-label="close" @click="showModal"></button>
    </div>
  </div>
</template>

<script>
  import firebase from 'firebase'
  import axios from 'axios'
  import Navbar from './Navbar'

  export default {
    name: 'Users',
    data: function() {
      return {
        show_me: false,
        triggeris: true,
        name: '',
        groups: [],
        current_user_id: firebase.auth().currentUser.uid,
        users: [],
        groups: [],
        admin: false,
        new_group: {
          name: "",
          read: false,
          write: false,
          create: false,
          delete: false,
          description: ""
        }
      }
    },
    components: {
      'nav-bar': Navbar,
    },
    methods: {
      showModal() {
        this.show_me = !this.show_me;
      },
      removeFromTable(list_id, rec_id) {
        this.users.splice(list_id);
        firebase.database().ref("users/" + rec_id).set(null);
      },
      saveChanges(list_id, rec_id, group_id) {
//Allow to assign group only if user is admin or has rights to do that.
        console.log(this.admin)
        console.log(this.group_id)
        this.users[list_id].isChanged = true;
        if(!this.admin)
          for (var id in this.groups){
          console.log('WOW')
            console.log(this.groups[id].Id);
            console.log(this.group_id);
            console.log(this.groups[id].Assign)
            if (((this.groups[id].Id == this.group_id) && !this.groups[id].Assign)){
              alert('You do not have rights to set groups!');
              return;
            }
          }
        firebase.database().ref("users/" + rec_id + "/group_id").set(group_id);
      },
    },
    mounted () {
      console.log(firebase.auth().currentUser.uid);
      this.current_user_id = firebase.auth().currentUser.uid;
      axios.get('https://unitask-604a4.firebaseio.com/users.json')
        .then( res => {
          for (var key in res.data){
//          Construct users objects.
            this.users.push(
              {
                isChanged: false,
                rec_id: key,
                id: res.data[key].id,
                name: res.data[key].name,
                group_id: res.data[key].group_id,
                email: res.data[key].email,
                admin: res.data[key].admin})
//            Get current connected user group to know whether it has rights to assign groups or not.
            if(res.data[key].id == this.current_user_id){
              this.group_id = res.data[key].group_id;
              this.admin = res.data[key].admin;
            }
          }
        axios.get('https://unitask-604a4.firebaseio.com/groups.json')
          .then( res => {
            for (var key in res.data){
              console.log(res.data[key].name);
              console.log(res.data[key].write);
              this.groups.push({Id: key, Name: res.data[key].name, Assign: res.data[key].write})
            }
          })
        })
//      axios.get('https://unitask-604a4.firebaseio.com/groups.json')
//        .then( res => {
//          for(var line in res.data) {
//            this.groups.push(res.data[line])
//            var index = this.groups.length
//            this.groups[index - 1].id = line
//          }
//        })
    },
  }
</script>

<style scoped>
  #create_group {
    margin-bottom: 10px;
  }
  .is-green {
    color: forestgreen;
  }
</style>
